﻿// 您能看到这条注释 Ricky 还是有点小激动的，如果您发现代码中哪里还有需要改进的地方，欢迎与我联系：contact@ccie.lol 。
// Ricky 还是欢迎您把代码推广和转发出去的。2019年5月15日17:13:44

// 1 . protocol , 2 . domain , 3 . other
function parseUrl(url) {
	if(typeof url == "undefined" || null == url)
		url = window.location.href;
	var regex = /(.*)\:\/\/([^\/]*)(.*)/i;
	return url.match(regex);
}

// 1 . protocol , 2 . surfing_prefix , 3 . other
function parseUrlForSurfingPrefix(url) {
	if(typeof url == "undefined" || null == url)
		url = window.location.href;
	var regex = /(.*)\:\/\/[^\/]*\/([^\/]*)(.*)/i;
	return url.match(regex);
}

// 1 . protocol , 2 . domain
function parseUrlForSurfingSite(url) {
	if(typeof url == "undefined" || null == url)
		url = window.location.href;
	var regex = /.*\:\/\/[^\/]*\/[^\/]*\/([^\/]*)\/([^\/]*).*/i;
	return url.match(regex);
}

function checkProtocol(protocol) {
	return ( protocol == 'http' || protocol == 'https' || protocol == 'ws' || protocol == 'wss' );
}

var tagInfoHashMap = {};

function requestListener(request) {
	var surfing_domain = localStorage.domain || 'surfing.makesky.net';
	var surfing_prefix = localStorage.prefix || '53136';
	var surfing_site = 'https://' + surfing_domain + '/' + surfing_prefix + '/';
	
	var key_protocol = 'surfing_tabid_' + request.tabId + '_protocol';
	var key_domain = 'surfing_tabid_' + request.tabId + '_domain';
	var match = parseUrl(request.url);
	// 1 . if not access surfing site , then redirect to surfing site .
	if ( match != null && match.length != null && match.length > 3 ) {
		var protocol = match[1].toLowerCase();
		var domain = match[2].toLowerCase();
		if ( checkProtocol(protocol) && domain != surfing_domain ) {
			// 2 . if the tagInfoHashMap does not Contain this item , update it .
			if ( typeof tagInfoHashMap[key_protocol] == "undefined" || typeof tagInfoHashMap[key_domain] == "undefined" ) {
				tagInfoHashMap[key_protocol] = protocol;
				tagInfoHashMap[key_domain] = domain;
			}
			//alert ('redirectUrl = ' + surfing_site + protocol + '/' + domain + match[3] );
			return { redirectUrl : surfing_site + protocol + '/' + domain + match[3] };
		}
	}
	
	// 3. if access surfing site , but surfing_prefix is wrong , then redirect to right URL .
	match = parseUrlForSurfingPrefix(request.url);
	if ( match != null && match.length != null && match.length > 3 ) {
		var protocol = match[1].toLowerCase();
		var domain = match[2];
		if ( checkProtocol(protocol) && domain != surfing_prefix ) {
			//alert( 'surfing_prefix is wrong - Tab ID = ' + request.tabId + ' , URL = ' + request.url + ' , protocol = ' + tagInfoHashMap[key_protocol] + ' , domain = ' + tagInfoHashMap[key_domain] + ' , redirectUrl = ' + surfing_site + tagInfoHashMap[key_protocol] + '/' + tagInfoHashMap[key_domain] + '/' + domain + match[3] );
			return { redirectUrl : surfing_site + tagInfoHashMap[key_protocol] + '/' + tagInfoHashMap[key_domain] + '/' + domain + match[3] };
		} else {
			// 4. if access surfing site , surfing_prefix and protocol is right , but tagInfoHashMap does not Contain this item , update it .
			match = parseUrlForSurfingSite(request.url);
			if ( match != null && match.length != null && match.length > 2 ) {
				var protocol = match[1].toLowerCase();
				var domain = match[2].toLowerCase();
				if ( checkProtocol(protocol) && ( typeof tagInfoHashMap[key_protocol] == "undefined" || typeof tagInfoHashMap[key_domain] == "undefined" ) ) {
					tagInfoHashMap[key_protocol] = protocol;
					tagInfoHashMap[key_domain] = domain;
					//alert( 'surfing_prefix and protocol is right - Tab ID = ' + request.tabId + ' , URL = ' + request.url + ' , protocol = ' + tagInfoHashMap[key_protocol] + ' , domain = ' + tagInfoHashMap[key_domain] );
				}
			}
		}
	}
}

chrome.webRequest.onBeforeRequest.addListener(requestListener, {urls : ["<all_urls>"]}, ["blocking"]);

function tabUpdateListener(tabId, changeInfo, tab) {
	if ( typeof changeInfo.url != 'undefined' && changeInfo.status == 'loading' ) {
		var match = parseUrlForSurfingSite(changeInfo.url);
		if (match != null && match.length != null && match.length > 2 ) {
			var protocol = match[1].toLowerCase();
			var domain = match[2].toLowerCase();
			if ( checkProtocol(protocol) ) {
				tagInfoHashMap['surfing_tabid_' + tabId + '_protocol'] = protocol;
				tagInfoHashMap['surfing_tabid_' + tabId + '_domain'] = domain
				//alert( 'tabUpdateListener - Tab ID = ' + tabId + ' , protocol = ' + tagInfoHashMap['surfing_tabid_' + tabId + '_protocol'] + ' , domain = ' + tagInfoHashMap['surfing_tabid_' + tabId + '_domain'] );
			}
		}
	}
}

chrome.tabs.onUpdated.addListener(tabUpdateListener);